<script setup lang="ts">
import 'swiper/css';
import 'swiper/css/keyboard';
import 'swiper/css/navigation';
import 'swiper/css/pagination';
import { register } from 'swiper/element/bundle';
import { nextTick, onMounted, onUnmounted, ref } from 'vue';
import { useRouter } from 'vue-router';

onMounted(() => {
  register();
});

const swiperRef = ref<HTMLElement | null>(null);
const timer = ref<number | null>(null);
const delay = 10000;
const isPaused = ref(false);
const progress = ref(0);
const interval = 100;
const iframeLoaded = ref(false);
const currentIndex = ref(0);
const grafanaPanels = ref<any[]>([]);
const router = useRouter();
const isLoading = ref(true);
const hasData = ref(false);

const loadJsonFromFile = async () => {
  try {
    isLoading.value = true; // Mostrar "Cargando..."
    
    const response = await fetch('/json/dashboards.json');
    if (!response.ok) throw new Error(`Error HTTP: ${response.status}`);

    const textData = await response.text();
    console.log('Contenido del archivo JSON:', textData);

    const jsonData = JSON.parse(textData);
    localStorage.setItem('dashboards', JSON.stringify(jsonData));

    isLoading.value = false; // Ocultar "Cargando..."
    window.location.reload();
  } catch (error) {s
    console.error('Error al cargar el archivo JSON:', error);
    isLoading.value = false; // Asegurar que "Cargando..." se oculta en caso de error
  }
};


const loadPanelsFromLocalStorage = () => {
  const grafanaUrl = (window as any).GRAFANA_URI;
  const storedData = localStorage.getItem('dashboards');
  if (storedData) {
    const parsedData = JSON.parse(storedData);
    grafanaPanels.value = parsedData.flatMap((dashboard: any) => 
      dashboard.panels.filter((panel: any) => panel.home_view === true)
      .map((panel: any) => ({ url: `${grafanaUrl}${dashboard.url}?orgId=1&refresh=10s&theme=light&viewPanel=${panel.id}&kiosk` }))
    );
    hasData.value = grafanaPanels.value.length > 0;
  } else {
    hasData.value = false;
    console.warn('No se encontraron datos en localStorage.');
    loadJsonFromFile();
  }
};

const goToLoadJson = () => router.push('/load_json');
const goToNextSlide = () => { if (swiperRef.value && !isPaused.value) swiperRef.value.swiper.slideNext(); };
const goToPreviousSlide = () => { if (swiperRef.value && !isPaused.value) swiperRef.value.swiper.slidePrev(); };

const onIframeLoaded = () => {
  if (!iframeLoaded.value) {
    isLoading.value = false;
    iframeLoaded.value = true;
    startTimer();
  }
};

const togglePause = () => {
  isPaused.value = !isPaused.value;
  if (isPaused.value && timer.value) clearInterval(timer.value);
  else startTimer();
};

const handleKeydown = (event: KeyboardEvent) => {
  if (event.code === 'Space') {
    event.preventDefault();
    togglePause();
  } else if (event.code === 'ArrowRight') {
    goToNextSlide();
  } else if (event.code === 'ArrowLeft') {
    goToPreviousSlide();
  }
};

const startTimer = () => {
  if (timer.value) clearInterval(timer.value);
  progress.value = 0;
  const steps = delay / interval;
  let currentStep = 0;
  timer.value = setInterval(() => {
    if (isPaused.value) return;
    currentStep += 1;
    progress.value = (currentStep / steps) * 100;
    if (currentStep >= steps) {
      if (swiperRef.value?.swiper.isEnd) {
        swiperRef.value.swiper.slideTo(0, 0);
      } else {
        goToNextSlide();
      }
      startTimer();
    }
  }, interval) as unknown as number;
};

const onSlideChange = () => {
  if (swiperRef.value) {
    currentIndex.value = swiperRef.value.swiper.realIndex;
    swiperRef.value.swiper.pagination.update();
  }
};

onMounted(() => {
  window.addEventListener('keydown', handleKeydown);
  loadPanelsFromLocalStorage();
  nextTick(() => {
    if (swiperRef.value) {
      swiperRef.value.swiper.on('slideChange', onSlideChange);
      swiperRef.value.swiper.update();
    }
  });
});

onUnmounted(() => {
  if (timer.value) clearInterval(timer.value);
  window.removeEventListener('keydown', handleKeydown);
});
</script>


<template>
  <div class="swiper-wrapper">
    
    <div v-if="!hasData" class="no-data-container">
      <p>Cargando datos</p>
      <p v-if="isLoading">Grafana...</p>
      <!--
      <VBtn v-else @click="goToLoadJson" color="primary">
        Cargar JSON
      </VBtn>
      -->
    </div>
    <!-- Barra de progreso inferior -->
    <div class="progress-bar">
      <div class="progress" :style="{ width: progress + '%' }"></div>
    </div>
    
    <swiper-container
      ref="swiperRef"
      :navigation="true"
      :pagination="true"
      :loop="true"
      :keyboard="true"
      class="my-swiper-container"
      space-between="30"
      slides-per-view="1"
      :looped-slides="grafanaPanels.length"       
      :loop-additional-slides="0"
      style=" position: relative; block-size: 500px;inline-size: 100%;"
    >
      <!-- Swiper Slide generados dinámicamente desde el JSON -->
      <swiper-slide
        v-for="(panel, index) in grafanaPanels"
        :key="index"
        class="swiper-slide"
      >
        <!-- Iframe de Grafana -->
        <iframe
          :src="panel.url"
          frameborder="0"
          style=" block-size: 100%;inline-size: 100%;"
          @load="onIframeLoaded"
        ></iframe>
      </swiper-slide>
    </swiper-container>

  </div>
</template>

<style scoped>
.my-swiper-container {
  block-size: 500px;
  inline-size: 100%;
}

.swiper-slide {
  display: flex;
  align-items: center;
  justify-content: center;
}

.progress-bar {
  position: absolute;
  z-index: 9;
  background-color: #e6e6e6;
  block-size: 2px;
  inline-size: 100%;
  inset-block-end: -2px;
  inset-inline-start: 0;
}

.progress {
  background-color: #4000ff;
  block-size: 100%;
  transition: inline-size 0.1s linear;
}

</style>
